/* luminanceMeter.h

	Include file for luminanceMeter.c code
	Please send suggestions, bugs, improvements, comments to f.w.cornelissen@med.rug.nl	
	Details in "read me" file and luminance.c file. Use at your own risk.


	21-02-97	fwc		created it	

*/


#include	<stdlib.h>
#include	<stdio.h>
#include	<Serial.h>
#include	<time.h>

#define PATIENCE				3.0			// time to wait for a message
#define REQUEST_LOW_TIME		0.01 		// how long is the DTR set LOW
#define MESSAGE_LENGTH			11

typedef enum
{
	MODEM_PORT,
	PRINTER_PORT
} portType;

typedef enum
{
	OUTPUT,
	INPUT
} driverType;

typedef enum
{
	HIGH = 17,
	LOW = 18
} dtrType;

#define returnDriverString(p,d) 	serialDriverString[p][d]
#define endLuminanceMeter()			closeSerialDriver()

int 	initLuminanceMeter( portType port );
int 	getLuminance( double *lum, char *message );
char 	*returnPortName( portType port );


int openSerialDriver( portType port );
int closeSerialDriver( void );
int sendMeasurementRequest( void );
int checkMeasurementPresent( double *t  );
int configureSerialPort( void );
int clearSerialBuffer( void );
int setHandshakeOptions( void );
int setDTR( dtrType dtr );
int serialDriverStatusCheck( void );
int checkSerialBuffer( void );

